-- // Code by SoundOfSpouting#6980 (UID: 151149148639330304)

data Tree = Leaf Char | Node Tree Tree

instance Read Tree where
  readsPrec _ ('`':xs) = do
    (x, ys) <- reads xs
    (y, zs) <- reads ys
    return (Node x y, zs)
  readsPrec _ (x:xs) = [(Leaf x, xs)]

instance Show Tree where
  show (Leaf x) = [x]
  show (Node x y) = '`' : show x ++ show y

invert (Node x y) = Node (invert y) (invert x)
invert x = x

entry = show . invert . read
